# coding: utf-8
"""Waylay rules engine api.

This code was generated from the OpenAPI documentation of 'Waylay rules engine'

Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.
"""

from __future__ import annotations  # for Python 3.7–3.9

from typing import (
    TYPE_CHECKING,
    Any,
    Dict,
    Literal,
    TypeVar,
    overload,
)

from pydantic import (
    Field,
    StrictBool,
    StrictStr,
    TypeAdapter,
)
from typing_extensions import (
    Annotated,  # >=3.9,
)

from waylay.sdk.api import (
    HeaderTypes,
    QueryParamTypes,
    RequestContent,
    Response,
)
from waylay.sdk.api._models import Model
from waylay.sdk.plugin import WithApiClient

if TYPE_CHECKING:
    from waylay.services.rules.models import ErrorResponse, NodeStateSpecification
    from waylay.services.rules.queries.task_nodes_api import (
        GetQuery,
        GetStatesQuery,
        PatchQuery,
        PostQuery,
        UpdateQuery,
    )


try:
    from waylay.services.rules.models import ErrorResponse, NodeStateSpecification
    from waylay.services.rules.queries.task_nodes_api import (
        GetQuery,
        GetStatesQuery,
        PatchQuery,
        PostQuery,
        UpdateQuery,
    )

    MODELS_AVAILABLE = True
except ImportError:
    MODELS_AVAILABLE = False

    if not TYPE_CHECKING:
        GetStatesQuery = dict

        GetQuery = dict

        ErrorResponse = Model

        NodeStateSpecification = Model

        PatchQuery = dict

        ErrorResponse = Model

        ErrorResponse = Model

        PostQuery = dict

        ErrorResponse = Model

        UpdateQuery = dict


T = TypeVar("T")


class TaskNodesApi(WithApiClient):
    """TaskNodesApi service methods.

    NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    @overload
    async def get_states(
        self,
        task_id: Annotated[StrictStr, Field(description="Unique Task identifier")],
        node_id: Annotated[StrictStr, Field(description="Unique node label")],
        *,
        query: GetStatesQuery | QueryParamTypes | None = None,
        raw_response: Literal[False] = False,
        select_path: Literal[""] = "",
        response_type: Literal[None] = None,
        validate_request: StrictBool = True,
        headers: HeaderTypes | None = None,
        **kwargs,
    ) -> object: ...

    @overload
    async def get_states(
        self,
        task_id: Annotated[StrictStr, Field(description="Unique Task identifier")],
        node_id: Annotated[StrictStr, Field(description="Unique node label")],
        *,
        query: GetStatesQuery | QueryParamTypes | None = None,
        raw_response: Literal[False] = False,
        select_path: Literal[""] = "",
        response_type: T,
        validate_request: StrictBool = True,
        headers: HeaderTypes | None = None,
        **kwargs,
    ) -> T: ...

    @overload
    async def get_states(
        self,
        task_id: Annotated[StrictStr, Field(description="Unique Task identifier")],
        node_id: Annotated[StrictStr, Field(description="Unique node label")],
        *,
        query: GetStatesQuery | QueryParamTypes | None = None,
        raw_response: Literal[True],
        select_path: Literal["_not_used_"] = "_not_used_",
        response_type: Literal[None] = None,  # not used
        validate_request: StrictBool = True,
        headers: HeaderTypes | None = None,
        **kwargs,
    ) -> Response: ...

    @overload
    async def get_states(
        self,
        task_id: Annotated[StrictStr, Field(description="Unique Task identifier")],
        node_id: Annotated[StrictStr, Field(description="Unique node label")],
        *,
        query: GetStatesQuery | QueryParamTypes | None = None,
        raw_response: Literal[False] = False,
        select_path: str,
        response_type: Literal[None] = None,
        validate_request: StrictBool = True,
        headers: HeaderTypes | None = None,
        **kwargs,
    ) -> Model: ...

    @overload
    async def get_states(
        self,
        task_id: Annotated[StrictStr, Field(description="Unique Task identifier")],
        node_id: Annotated[StrictStr, Field(description="Unique node label")],
        *,
        query: GetStatesQuery | QueryParamTypes | None = None,
        raw_response: Literal[False] = False,
        select_path: str,
        response_type: T,
        validate_request: StrictBool = True,
        headers: HeaderTypes | None = None,
        **kwargs,
    ) -> T: ...

    async def get_states(
        self,
        task_id: Annotated[StrictStr, Field(description="Unique Task identifier")],
        node_id: Annotated[StrictStr, Field(description="Unique node label")],
        *,
        query: GetStatesQuery | QueryParamTypes | None = None,
        raw_response: StrictBool = False,
        select_path: str = "",
        response_type: T | None = None,
        validate_request: StrictBool = True,
        headers: HeaderTypes | None = None,
        **kwargs,
    ) -> object | T | Response | Model:
        """Get Supported States.

        Get the supported states of a node.  #### visibility This definition has visibility status `deprecated`.
        :param task_id: Unique Task identifier (required)
        :type task_id: str
        :param node_id: Unique node label (required)
        :type node_id: str
        :param query: URL Query parameters.
        :type query: GetStatesQuery | QueryParamTypes, optional
        :param raw_response: If true, return the http Response object instead of returning an api model object, or throwing an ApiError.
        :param select_path: Denotes the json path applied to the response object before returning it.
                Set it to the empty string `""` to receive the full response object.
        :param response_type: If specified, the response is parsed into an instance of the specified type.
        :param validate_request: If set to false, the request body and query parameters are NOT validated against the models in the service types package, even when available.
        :param headers: Header parameters for this request
        :type headers: dict, optional
        :param `**kwargs`: Additional parameters passed on to the http client.
            See below.
        :Keyword Arguments:
            * timeout: a single numeric timeout in seconds,
                or a tuple of _connect_, _read_, _write_ and _pool_ timeouts.
            * stream: if true, the response will be in streaming mode
            * cookies
            * extensions
            * auth
            * follow_redirects: bool

        :return: Returns the result object if the http request succeeded with status code '2XX'.
        :raises APIError: If the http request has a status code different from `2XX`. This
            object wraps both the http Response and any parsed data.
        """

        # path parameters
        path_params: Dict[str, str] = {
            "taskId": str(task_id),
            "nodeId": str(node_id),
        }

        ## named body parameters
        body_args: Dict[str, Any] = {}

        # query parameters
        if query is not None and MODELS_AVAILABLE and validate_request:
            query = TypeAdapter(GetStatesQuery).validate_python(query)

        response_types_map: Dict[str, Any] = (
            {"2XX": response_type}
            if response_type is not None
            else {
                "200": object if not select_path else Model,
            }
        )
        non_200_response_types_map: Dict[str, Any] = {}
        response_types_map.update(non_200_response_types_map)

        ## peform request
        return await self.api_client.request(
            method="GET",
            resource_path="/rules/v1/tasks/{taskId}/nodes/{nodeId}/states",
            path_params=path_params,
            params=query,
            **body_args,
            headers=headers,
            **kwargs,
            response_type=response_types_map,
            select_path=select_path,
            raw_response=raw_response,
        )

    @overload
    async def get(
        self,
        task_id: Annotated[StrictStr, Field(description="Unique Task identifier")],
        node_id: Annotated[StrictStr, Field(description="Unique node label")],
        *,
        query: GetQuery | QueryParamTypes | None = None,
        raw_response: Literal[False] = False,
        select_path: Literal[""] = "",
        response_type: Literal[None] = None,
        validate_request: StrictBool = True,
        headers: HeaderTypes | None = None,
        **kwargs,
    ) -> object: ...

    @overload
    async def get(
        self,
        task_id: Annotated[StrictStr, Field(description="Unique Task identifier")],
        node_id: Annotated[StrictStr, Field(description="Unique node label")],
        *,
        query: GetQuery | QueryParamTypes | None = None,
        raw_response: Literal[False] = False,
        select_path: Literal[""] = "",
        response_type: T,
        validate_request: StrictBool = True,
        headers: HeaderTypes | None = None,
        **kwargs,
    ) -> T: ...

    @overload
    async def get(
        self,
        task_id: Annotated[StrictStr, Field(description="Unique Task identifier")],
        node_id: Annotated[StrictStr, Field(description="Unique node label")],
        *,
        query: GetQuery | QueryParamTypes | None = None,
        raw_response: Literal[True],
        select_path: Literal["_not_used_"] = "_not_used_",
        response_type: Literal[None] = None,  # not used
        validate_request: StrictBool = True,
        headers: HeaderTypes | None = None,
        **kwargs,
    ) -> Response: ...

    @overload
    async def get(
        self,
        task_id: Annotated[StrictStr, Field(description="Unique Task identifier")],
        node_id: Annotated[StrictStr, Field(description="Unique node label")],
        *,
        query: GetQuery | QueryParamTypes | None = None,
        raw_response: Literal[False] = False,
        select_path: str,
        response_type: Literal[None] = None,
        validate_request: StrictBool = True,
        headers: HeaderTypes | None = None,
        **kwargs,
    ) -> Model: ...

    @overload
    async def get(
        self,
        task_id: Annotated[StrictStr, Field(description="Unique Task identifier")],
        node_id: Annotated[StrictStr, Field(description="Unique node label")],
        *,
        query: GetQuery | QueryParamTypes | None = None,
        raw_response: Literal[False] = False,
        select_path: str,
        response_type: T,
        validate_request: StrictBool = True,
        headers: HeaderTypes | None = None,
        **kwargs,
    ) -> T: ...

    async def get(
        self,
        task_id: Annotated[StrictStr, Field(description="Unique Task identifier")],
        node_id: Annotated[StrictStr, Field(description="Unique node label")],
        *,
        query: GetQuery | QueryParamTypes | None = None,
        raw_response: StrictBool = False,
        select_path: str = "",
        response_type: T | None = None,
        validate_request: StrictBool = True,
        headers: HeaderTypes | None = None,
        **kwargs,
    ) -> object | T | Response | Model:
        """Get Current States.

        Get current states (posteriors) and raw data of the node.  #### visibility This definition has visibility status `deprecated`.
        :param task_id: Unique Task identifier (required)
        :type task_id: str
        :param node_id: Unique node label (required)
        :type node_id: str
        :param query: URL Query parameters.
        :type query: GetQuery | QueryParamTypes, optional
        :param raw_response: If true, return the http Response object instead of returning an api model object, or throwing an ApiError.
        :param select_path: Denotes the json path applied to the response object before returning it.
                Set it to the empty string `""` to receive the full response object.
        :param response_type: If specified, the response is parsed into an instance of the specified type.
        :param validate_request: If set to false, the request body and query parameters are NOT validated against the models in the service types package, even when available.
        :param headers: Header parameters for this request
        :type headers: dict, optional
        :param `**kwargs`: Additional parameters passed on to the http client.
            See below.
        :Keyword Arguments:
            * timeout: a single numeric timeout in seconds,
                or a tuple of _connect_, _read_, _write_ and _pool_ timeouts.
            * stream: if true, the response will be in streaming mode
            * cookies
            * extensions
            * auth
            * follow_redirects: bool

        :return: Returns the result object if the http request succeeded with status code '2XX'.
        :raises APIError: If the http request has a status code different from `2XX`. This
            object wraps both the http Response and any parsed data.
        """

        # path parameters
        path_params: Dict[str, str] = {
            "taskId": str(task_id),
            "nodeId": str(node_id),
        }

        ## named body parameters
        body_args: Dict[str, Any] = {}

        # query parameters
        if query is not None and MODELS_AVAILABLE and validate_request:
            query = TypeAdapter(GetQuery).validate_python(query)

        response_types_map: Dict[str, Any] = (
            {"2XX": response_type}
            if response_type is not None
            else {
                "200": object if not select_path else Model,
            }
        )
        non_200_response_types_map: Dict[str, Any] = {
            "404": ErrorResponse,
        }
        response_types_map.update(non_200_response_types_map)

        ## peform request
        return await self.api_client.request(
            method="GET",
            resource_path="/rules/v1/tasks/{taskId}/nodes/{nodeId}",
            path_params=path_params,
            params=query,
            **body_args,
            headers=headers,
            **kwargs,
            response_type=response_types_map,
            select_path=select_path,
            raw_response=raw_response,
        )

    @overload
    async def patch(
        self,
        task_id: Annotated[StrictStr, Field(description="Unique Task identifier")],
        node_id: Annotated[StrictStr, Field(description="Unique node label")],
        *,
        json: NodeStateSpecification,
        query: PatchQuery | QueryParamTypes | None = None,
        raw_response: Literal[False] = False,
        select_path: Literal[""] = "",
        response_type: Literal[None] = None,
        validate_request: StrictBool = True,
        headers: HeaderTypes | None = None,
        **kwargs,
    ) -> object: ...

    @overload
    async def patch(
        self,
        task_id: Annotated[StrictStr, Field(description="Unique Task identifier")],
        node_id: Annotated[StrictStr, Field(description="Unique node label")],
        *,
        json: NodeStateSpecification,
        query: PatchQuery | QueryParamTypes | None = None,
        raw_response: Literal[False] = False,
        select_path: Literal[""] = "",
        response_type: T,
        validate_request: StrictBool = True,
        headers: HeaderTypes | None = None,
        **kwargs,
    ) -> T: ...

    @overload
    async def patch(
        self,
        task_id: Annotated[StrictStr, Field(description="Unique Task identifier")],
        node_id: Annotated[StrictStr, Field(description="Unique node label")],
        *,
        json: NodeStateSpecification,
        query: PatchQuery | QueryParamTypes | None = None,
        raw_response: Literal[True],
        select_path: Literal["_not_used_"] = "_not_used_",
        response_type: Literal[None] = None,  # not used
        validate_request: StrictBool = True,
        headers: HeaderTypes | None = None,
        **kwargs,
    ) -> Response: ...

    @overload
    async def patch(
        self,
        task_id: Annotated[StrictStr, Field(description="Unique Task identifier")],
        node_id: Annotated[StrictStr, Field(description="Unique node label")],
        *,
        json: NodeStateSpecification,
        query: PatchQuery | QueryParamTypes | None = None,
        raw_response: Literal[False] = False,
        select_path: str,
        response_type: Literal[None] = None,
        validate_request: StrictBool = True,
        headers: HeaderTypes | None = None,
        **kwargs,
    ) -> Model: ...

    @overload
    async def patch(
        self,
        task_id: Annotated[StrictStr, Field(description="Unique Task identifier")],
        node_id: Annotated[StrictStr, Field(description="Unique node label")],
        *,
        json: NodeStateSpecification,
        query: PatchQuery | QueryParamTypes | None = None,
        raw_response: Literal[False] = False,
        select_path: str,
        response_type: T,
        validate_request: StrictBool = True,
        headers: HeaderTypes | None = None,
        **kwargs,
    ) -> T: ...

    async def patch(
        self,
        task_id: Annotated[StrictStr, Field(description="Unique Task identifier")],
        node_id: Annotated[StrictStr, Field(description="Unique node label")],
        *,
        json: NodeStateSpecification,
        query: PatchQuery | QueryParamTypes | None = None,
        raw_response: StrictBool = False,
        select_path: str = "",
        response_type: T | None = None,
        validate_request: StrictBool = True,
        headers: HeaderTypes | None = None,
        **kwargs,
    ) -> object | T | Response | Model:
        """Set Node State.

        Set the current state and rawData for the node. This can only be done for a running task
        :param task_id: Unique Task identifier (required)
        :type task_id: str
        :param node_id: Unique node label (required)
        :type node_id: str
        :param json: The json request body.
        :type json: NodeStateSpecification, optional
        :param query: URL Query parameters.
        :type query: PatchQuery | QueryParamTypes, optional
        :param raw_response: If true, return the http Response object instead of returning an api model object, or throwing an ApiError.
        :param select_path: Denotes the json path applied to the response object before returning it.
                Set it to the empty string `""` to receive the full response object.
        :param response_type: If specified, the response is parsed into an instance of the specified type.
        :param validate_request: If set to false, the request body and query parameters are NOT validated against the models in the service types package, even when available.
        :param headers: Header parameters for this request
        :type headers: dict, optional
        :param `**kwargs`: Additional parameters passed on to the http client.
            See below.
        :Keyword Arguments:
            * timeout: a single numeric timeout in seconds,
                or a tuple of _connect_, _read_, _write_ and _pool_ timeouts.
            * stream: if true, the response will be in streaming mode
            * cookies
            * extensions
            * auth
            * follow_redirects: bool

        :return: Returns the result object if the http request succeeded with status code '2XX'.
        :raises APIError: If the http request has a status code different from `2XX`. This
            object wraps both the http Response and any parsed data.
        """

        # path parameters
        path_params: Dict[str, str] = {
            "taskId": str(task_id),
            "nodeId": str(node_id),
        }

        ## named body parameters
        body_args: Dict[str, Any] = {}
        if json is not None and validate_request:
            body_adapter: Any = TypeAdapter(NodeStateSpecification)
            json = body_adapter.validate_python(json)  # type: ignore # https://github.com/pydantic/pydantic/discussions/7094
        body_args["json"] = json

        # query parameters
        if query is not None and MODELS_AVAILABLE and validate_request:
            query = TypeAdapter(PatchQuery).validate_python(query)

        response_types_map: Dict[str, Any] = (
            {"2XX": response_type}
            if response_type is not None
            else {
                "200": object if not select_path else Model,
            }
        )
        non_200_response_types_map: Dict[str, Any] = {
            "400": ErrorResponse,
            "404": ErrorResponse,
        }
        response_types_map.update(non_200_response_types_map)

        ## peform request
        return await self.api_client.request(
            method="PATCH",
            resource_path="/rules/v1/tasks/{taskId}/nodes/{nodeId}",
            path_params=path_params,
            params=query,
            **body_args,
            headers=headers,
            **kwargs,
            response_type=response_types_map,
            select_path=select_path,
            raw_response=raw_response,
        )

    @overload
    async def post(
        self,
        *,
        content: Annotated[
            RequestContent | None,
            Field(description="Callback result to be passed to the plugin"),
        ] = None,
        query: PostQuery | QueryParamTypes | None = None,
        raw_response: Literal[False] = False,
        select_path: Literal[""] = "",
        response_type: Literal[None] = None,
        validate_request: StrictBool = True,
        headers: HeaderTypes | None = None,
        **kwargs,
    ) -> object: ...

    @overload
    async def post(
        self,
        *,
        content: Annotated[
            RequestContent | None,
            Field(description="Callback result to be passed to the plugin"),
        ] = None,
        query: PostQuery | QueryParamTypes | None = None,
        raw_response: Literal[False] = False,
        select_path: Literal[""] = "",
        response_type: T,
        validate_request: StrictBool = True,
        headers: HeaderTypes | None = None,
        **kwargs,
    ) -> T: ...

    @overload
    async def post(
        self,
        *,
        content: Annotated[
            RequestContent | None,
            Field(description="Callback result to be passed to the plugin"),
        ] = None,
        query: PostQuery | QueryParamTypes | None = None,
        raw_response: Literal[True],
        select_path: Literal["_not_used_"] = "_not_used_",
        response_type: Literal[None] = None,  # not used
        validate_request: StrictBool = True,
        headers: HeaderTypes | None = None,
        **kwargs,
    ) -> Response: ...

    @overload
    async def post(
        self,
        *,
        content: Annotated[
            RequestContent | None,
            Field(description="Callback result to be passed to the plugin"),
        ] = None,
        query: PostQuery | QueryParamTypes | None = None,
        raw_response: Literal[False] = False,
        select_path: str,
        response_type: Literal[None] = None,
        validate_request: StrictBool = True,
        headers: HeaderTypes | None = None,
        **kwargs,
    ) -> Model: ...

    @overload
    async def post(
        self,
        *,
        content: Annotated[
            RequestContent | None,
            Field(description="Callback result to be passed to the plugin"),
        ] = None,
        query: PostQuery | QueryParamTypes | None = None,
        raw_response: Literal[False] = False,
        select_path: str,
        response_type: T,
        validate_request: StrictBool = True,
        headers: HeaderTypes | None = None,
        **kwargs,
    ) -> T: ...

    async def post(
        self,
        *,
        content: Annotated[
            RequestContent | None,
            Field(description="Callback result to be passed to the plugin"),
        ] = None,
        query: PostQuery | QueryParamTypes | None = None,
        raw_response: StrictBool = False,
        select_path: str = "",
        response_type: T | None = None,
        validate_request: StrictBool = True,
        headers: HeaderTypes | None = None,
        **kwargs,
    ) -> object | T | Response | Model:
        """Finalize Asynchronous Execution With Token.

        Post a result to finalize an asynchronous plugin execution using the onetime token from the callback url.
        :param content: Callback result to be passed to the plugin
        :type content: ContentRequest, optional
        :param query: URL Query parameters.
        :type query: PostQuery | QueryParamTypes, optional
        :param query['access_token'] (dict) <br> query.access_token (Query) : Token that was given in the callback url (required)
        :type query['access_token']: str
        :param raw_response: If true, return the http Response object instead of returning an api model object, or throwing an ApiError.
        :param select_path: Denotes the json path applied to the response object before returning it.
                Set it to the empty string `""` to receive the full response object.
        :param response_type: If specified, the response is parsed into an instance of the specified type.
        :param validate_request: If set to false, the request body and query parameters are NOT validated against the models in the service types package, even when available.
        :param headers: Header parameters for this request
        :type headers: dict, optional
        :param `**kwargs`: Additional parameters passed on to the http client.
            See below.
        :Keyword Arguments:
            * timeout: a single numeric timeout in seconds,
                or a tuple of _connect_, _read_, _write_ and _pool_ timeouts.
            * stream: if true, the response will be in streaming mode
            * cookies
            * extensions
            * auth
            * follow_redirects: bool

        :return: Returns the result object if the http request succeeded with status code '2XX'.
        :raises APIError: If the http request has a status code different from `2XX`. This
            object wraps both the http Response and any parsed data.
        """

        # path parameters
        path_params: Dict[str, str] = {}

        ## named body parameters
        body_args: Dict[str, Any] = {}
        body_args["content"] = content

        # query parameters
        if query is not None and MODELS_AVAILABLE and validate_request:
            query = TypeAdapter(PostQuery).validate_python(query)

        response_types_map: Dict[str, Any] = (
            {"2XX": response_type}
            if response_type is not None
            else {
                "200": object if not select_path else Model,
            }
        )
        non_200_response_types_map: Dict[str, Any] = {
            "403": ErrorResponse,
        }
        response_types_map.update(non_200_response_types_map)

        ## peform request
        return await self.api_client.request(
            method="POST",
            resource_path="/rules/v1/tasks/callback",
            path_params=path_params,
            params=query,
            **body_args,
            headers=headers,
            **kwargs,
            response_type=response_types_map,
            select_path=select_path,
            raw_response=raw_response,
        )

    @overload
    async def update(
        self,
        task_id: Annotated[StrictStr, Field(description="Unique Task identifier")],
        node_id: Annotated[StrictStr, Field(description="Unique node label")],
        *,
        content: Annotated[
            RequestContent | None,
            Field(description="Command string to apply to a node of a task."),
        ] = None,
        query: UpdateQuery | QueryParamTypes | None = None,
        raw_response: Literal[False] = False,
        select_path: Literal[""] = "",
        response_type: Literal[None] = None,
        validate_request: StrictBool = True,
        headers: HeaderTypes | None = None,
        **kwargs,
    ) -> object: ...

    @overload
    async def update(
        self,
        task_id: Annotated[StrictStr, Field(description="Unique Task identifier")],
        node_id: Annotated[StrictStr, Field(description="Unique node label")],
        *,
        content: Annotated[
            RequestContent | None,
            Field(description="Command string to apply to a node of a task."),
        ] = None,
        query: UpdateQuery | QueryParamTypes | None = None,
        raw_response: Literal[False] = False,
        select_path: Literal[""] = "",
        response_type: T,
        validate_request: StrictBool = True,
        headers: HeaderTypes | None = None,
        **kwargs,
    ) -> T: ...

    @overload
    async def update(
        self,
        task_id: Annotated[StrictStr, Field(description="Unique Task identifier")],
        node_id: Annotated[StrictStr, Field(description="Unique node label")],
        *,
        content: Annotated[
            RequestContent | None,
            Field(description="Command string to apply to a node of a task."),
        ] = None,
        query: UpdateQuery | QueryParamTypes | None = None,
        raw_response: Literal[True],
        select_path: Literal["_not_used_"] = "_not_used_",
        response_type: Literal[None] = None,  # not used
        validate_request: StrictBool = True,
        headers: HeaderTypes | None = None,
        **kwargs,
    ) -> Response: ...

    @overload
    async def update(
        self,
        task_id: Annotated[StrictStr, Field(description="Unique Task identifier")],
        node_id: Annotated[StrictStr, Field(description="Unique node label")],
        *,
        content: Annotated[
            RequestContent | None,
            Field(description="Command string to apply to a node of a task."),
        ] = None,
        query: UpdateQuery | QueryParamTypes | None = None,
        raw_response: Literal[False] = False,
        select_path: str,
        response_type: Literal[None] = None,
        validate_request: StrictBool = True,
        headers: HeaderTypes | None = None,
        **kwargs,
    ) -> Model: ...

    @overload
    async def update(
        self,
        task_id: Annotated[StrictStr, Field(description="Unique Task identifier")],
        node_id: Annotated[StrictStr, Field(description="Unique node label")],
        *,
        content: Annotated[
            RequestContent | None,
            Field(description="Command string to apply to a node of a task."),
        ] = None,
        query: UpdateQuery | QueryParamTypes | None = None,
        raw_response: Literal[False] = False,
        select_path: str,
        response_type: T,
        validate_request: StrictBool = True,
        headers: HeaderTypes | None = None,
        **kwargs,
    ) -> T: ...

    async def update(
        self,
        task_id: Annotated[StrictStr, Field(description="Unique Task identifier")],
        node_id: Annotated[StrictStr, Field(description="Unique node label")],
        *,
        content: Annotated[
            RequestContent | None,
            Field(description="Command string to apply to a node of a task."),
        ] = None,
        query: UpdateQuery | QueryParamTypes | None = None,
        raw_response: StrictBool = False,
        select_path: str = "",
        response_type: T | None = None,
        validate_request: StrictBool = True,
        headers: HeaderTypes | None = None,
        **kwargs,
    ) -> object | T | Response | Model:
        """Set Current State.

        Set the current state of the node.  This call is deprecated. Please use `PATCH /rules/v1/tasks/{taskId}/nodes/{nodeId}`  #### visibility This definition has visibility status `deprecated`.
        :param task_id: Unique Task identifier (required)
        :type task_id: str
        :param node_id: Unique node label (required)
        :type node_id: str
        :param content: Command string to apply to a node of a task.
        :type content: ContentRequest, optional
        :param query: URL Query parameters.
        :type query: UpdateQuery | QueryParamTypes, optional
        :param raw_response: If true, return the http Response object instead of returning an api model object, or throwing an ApiError.
        :param select_path: Denotes the json path applied to the response object before returning it.
                Set it to the empty string `""` to receive the full response object.
        :param response_type: If specified, the response is parsed into an instance of the specified type.
        :param validate_request: If set to false, the request body and query parameters are NOT validated against the models in the service types package, even when available.
        :param headers: Header parameters for this request
        :type headers: dict, optional
        :param `**kwargs`: Additional parameters passed on to the http client.
            See below.
        :Keyword Arguments:
            * timeout: a single numeric timeout in seconds,
                or a tuple of _connect_, _read_, _write_ and _pool_ timeouts.
            * stream: if true, the response will be in streaming mode
            * cookies
            * extensions
            * auth
            * follow_redirects: bool

        :return: Returns the result object if the http request succeeded with status code '2XX'.
        :raises APIError: If the http request has a status code different from `2XX`. This
            object wraps both the http Response and any parsed data.
        """

        # path parameters
        path_params: Dict[str, str] = {
            "taskId": str(task_id),
            "nodeId": str(node_id),
        }

        ## named body parameters
        body_args: Dict[str, Any] = {}
        body_args["content"] = content

        # query parameters
        if query is not None and MODELS_AVAILABLE and validate_request:
            query = TypeAdapter(UpdateQuery).validate_python(query)

        response_types_map: Dict[str, Any] = (
            {"2XX": response_type}
            if response_type is not None
            else {
                "200": object if not select_path else Model,
            }
        )
        non_200_response_types_map: Dict[str, Any] = {}
        response_types_map.update(non_200_response_types_map)

        ## peform request
        return await self.api_client.request(
            method="POST",
            resource_path="/rules/v1/tasks/{taskId}/nodes/{nodeId}",
            path_params=path_params,
            params=query,
            **body_args,
            headers=headers,
            **kwargs,
            response_type=response_types_map,
            select_path=select_path,
            raw_response=raw_response,
        )
